#ifndef TOOLS_HPP
#define TOOLS_HPP

void errorMessage(const wchar_t *msg);
intptr_t messageBox  (unsigned long flags, const wchar_t * const *items, int noItems, int noButtons);

const wchar_t* pointToName(const wchar_t *path);
wchar_t* pointToName(wchar_t *path);

const wchar_t* pointToExt(const wchar_t *path);
wchar_t* pointToExt(wchar_t *path);

char* trim(char *str);
wchar_t* trim(wchar_t *str);

wchar_t* truncPathStr  (wchar_t *newName, const wchar_t *name, int noChars);
void  addEndSlash   (wchar_t *path);
void  quoteSpaceOnly(wchar_t *buf);

bool isValidChar (BYTE ch);
bool isValidFolderChar(BYTE ch); //   

bool isEnAlphaNum (BYTE ch);
void makeTrDosName(wchar_t* dest, const struct SCLHdr &hdr, bool ShowExt, int width);

WORD crc (BYTE* ptr, size_t len);

DWORD calculateCheckSum(BYTE* ptr, size_t size);
WORD  calculateCheckSum(struct HoHdr& hdr);

//  PC   ZX 
char* make8x3name(const wchar_t* source, char* dest);

const wchar_t *GetMsg(intptr_t MsgId);

void SafeDlgFree(HANDLE Dlg);

wchar_t Cp866ToUcs2(char x);

FileType detectFileType(HANDLE file);

int str2int(const wchar_t* p, int len);

void makePCName(const char *from, wchar_t *to);

DWORD writeSCLHeader(HANDLE file, BYTE no_files);

#endif
