#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "types.hpp"
#include "trdos.hpp"
#include "make.hpp"

bool createFDI(Track0 track0, int totalSecs, BYTE *interleave, BYTE writeProtect, HANDLE image, HANDLE boot, const char *comment)
{
  int i,j;
  DWORD noBytesWritten;
  DWORD noBytesRead;

  BYTE emptySec[secSize];
  ZeroMemory(emptySec, secSize);

  // 
  BYTE FDIHdr[] =
  {
    'F', 'D', 'I',        // 
    0x00,                 //     (0 - write enabled, 1 - write disabled)
    0x50, 0x00,           //   (80)
    0x02, 0x00,           //  
    0x6E, 0x4A,           //   (   )
    0x00, 0x4B,           //  
    0x00, 0x00            //     
  };
  FDIHdr[3] = writeProtect;
  WriteFile(image, FDIHdr, sizeof(FDIHdr), &noBytesWritten, NULL);

  // 
  for(i = 0; i < 2*noTrks; ++i)
  {
    FDITrk trk;
    trk.offset   = secSize * noSecs * i;
    trk.reserved = 0;
    trk.noSecs   = noSecs;
    WriteFile(image, &trk, sizeof(FDITrk), &noBytesWritten, NULL);
    for(j = 0; j < noSecs; ++j)
    {
      BYTE secHdr[7] = { 0, 0, 0, 1, 2, 0, 0 };
      secHdr[0] = i/2;
      secHdr[2] = interleave[j];
      secHdr[6] = interleave[j] - 1;
      WriteFile(image, secHdr, sizeof(secHdr), &noBytesWritten, NULL);
    }
  }

  //
  if(comment)
  {
    WriteFile(image, comment, lstrlen(comment), &noBytesWritten, NULL);
    WriteFile(image, emptySec, 146-lstrlen(comment), &noBytesWritten, NULL);
  }
  else
    WriteFile(image, emptySec, 146, &noBytesWritten, NULL);

  // 0
  SetFilePointer(image, 0x4B00, NULL, FILE_BEGIN);
  WriteFile(image, &track0, sizeof(Track0), &noBytesWritten, NULL);

  //
  for(i = 0; i < totalSecs; ++i)
  {
    BYTE buf[secSize];
    ReadFile(boot, buf, secSize, &noBytesRead, NULL);
    WriteFile(image, buf, secSize, &noBytesWritten, NULL);
  }

  // 
  for(i = totalSecs; i < 2544; ++i)
    WriteFile(image, emptySec, secSize, &noBytesWritten, NULL);

  return true;
}
